
/*
    Copyright, 1991, The Regents of the University of
    California.  This software was produced under a U. S.
    Government contract (W-7405-ENG-36) by the Los Alamos
    National Laboratory, which is operated by the
    University of California for the U. S. Department of
    Energy.  The U. S. Government is licensed to use,
    reproduce, and distribute this software.  Permission
    is granted to the public to copy and use this software
    without charge, provided that this Notice and any statement
    of authorship are reproduced on all copies.  Neither the
    Government nor the University makes any warranty, express
    or implied, or assumes any liability or responsibility for
    the use of this software.


     Software Author:  Frank A. Ortega, X-6 (505) 665-0688

*/

/*
   cc gmvmovie.c -o gmvmovie -lXm_s -lXt_s -lX11 -lPW
*/

#include <stdio.h>
#include <stdlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xutil.h>
#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/RowColumn.h>
#include <Xm/ToggleBG.h>
#include <Xm/PushBG.h>

static char *pw = "               ";

Widget localbutton, scriptbutton, cfsbutton, scriptcfsbutton, msglab,
       crayfield, pathfield, prefixfield, firstfield, lastfield,
       stridefield, attributesfield, quad1, quad2, quad3, quad4,
       rgbfield, rgbstart, readybutton, quitbutton, scriptfield;

short continueflag = 0, cfs = 0, local = 0, snapshot = 1, script = 0;
char craymx[2], path[200], prefix[40], attributesfile[200],
     scriptfile[80], rgbprefix[40];
int startnum, endnum, stride = 1, tries, startrgbno;
char win_pos[30];



main()

{
  XtAppContext app;
  Widget toplevel;
  char *sl, header[250], header1[250], number[250],
       number1[4], rmstring[200], infile[80], header2[250],
       gmvin[200], gmvinhdr[80];
  char progdata[80], path1[200], snapstring[80], snapstring1[80],
       sframenum[5], framenumstring[5];
  int i, ret, loop, breakout = 0, framenum = 0, argc = 0;
  char **argv, *getpass();
  FILE *in;
  XmString string;
  XEvent event;
  void create_form_mainform();


   /*  Initialize Xt.  */
   toplevel = XtAppInitialize(&app, "GMVmovie", 
			      (XrmOptionDescList)NULL , 0,
			      (Cardinal*)&argc, 
			      (String*)argv, 
                              (String*)NULL,
		              (ArgList)NULL, 0);
   XtVaSetValues(toplevel,
                 XtNtitle,"GMV Movie",
                 XtNx, 0, XtNy, 0,
                 /* XtNheight,10, XtNwidth, 10, */
                 NULL);

   /*  Set defaults with a blank for later checks.  */
   strcpy(craymx," ");
   strcpy(path," ");
   strcpy(attributesfile," ");
   strcpy(pw," ");
   strcpy(prefix," ");
   strcpy(win_pos," -w 639 0 640 512 -i ");

   /*  Create motif widgets and realize the menu.  */
   create_form_mainform(toplevel);
   XtRealizeWidget(toplevel);

   /*  Loop until ready button pressed.  */
   while (continueflag == 0)
     {
      XtAppNextEvent(app, &event);
      XtDispatchEvent(&event);
     }

   /*  Pop down the window and start the movie process.  */
   XtUnrealizeWidget(toplevel);
   XmUpdateDisplay(toplevel);

   /*  If files are not local, we have to get a  */
   /*  CFS pw and check for ICN security level.  */
   if (local == 0)
     {

      /*  If the user has not initiated kinit, quit.  */ 
      sl = getenv("ICNCHARGE");
      if ((int)sl == 0)
        {
         printf("Set ICNCHARGE and make sure kinit "
                "has been initialized.\n");
         exit(0);
        }

       /*  If getting input files from CFS mass  */
       /*  storage, enter password, if needed.   */
       if (cfs == 1) strcpy(pw,getpass("Enter CFS pw:  "));

/*
       if ((cray == 1) && (strncmp(craymx," ",1) == 0))
         {
          printf("Enter Cray machine name:  ");
          scanf("%s",craymx);
          printf("\n");
         }
*/
     }   
  
/*
   if (cray == 1)
     {
      strcpy(header,"kcp ");
      strcat(header,craymx);
      strcat(header,":");
     }
*/

   /*  If getting input files from CFS mass storage,  */
   /*  add the cfsgw command to the command list.     */
   if (cfs == 1)
     {
      strcpy(header,"/usr/local/bin/cfs get");

      if (strlen(pw) > 0)
        {
         strcat(header," pw=");
         strcat(header,pw);
        }
      strcat(header," ");
     } 

   /*  Set up the gmv command for movie mode with  the  */
   /*  attributes file and window location selected.    */
   strcpy(gmvinhdr,"gmv -m");
   if (strncmp(attributesfile," ",1) != 0)
     {
      strcat(gmvinhdr, " -a ");
      strcat(gmvinhdr,attributesfile);
     }
   strcat(gmvinhdr,win_pos);

   /*  Get the cfs path or alternate path  */
   /*   and script file, if entered.       */
   if (strncmp(path," ",1) != 0) strcat(path,"/");
   if (script == 1) in = fopen(scriptfile,"r");

   /*  Start the command to move the AzsnapgmvAz file  */
   /*  generated by gmv to the output rgb filename.    */
   strcpy(snapstring,"mv AzsnapgmvAz ");
   strcat(snapstring,rgbprefix);
   framenum = startrgbno - 1;

   /*  Loop through the input files selected.  */
   loop = 1;
   while (loop == 1)
     {

      /*  Read and set input file info. from a script.  */
      if (script == 1)
        {
         if (fgets(progdata,80,in) == NULL) breakout = 1;
         if (strlen(progdata) > 1)
           {
            sscanf(progdata,"%s %d %d %d\n",prefix,&startnum,
                   &endnum,&stride);
           }
         else
           {
            breakout = 1;
           }
        }

      if (breakout == 1) break;

      /*  Create input file path and prefix.  */
      strcpy(path1,path);
      strcat(path1,prefix);

      /*  Add 3 digit input file no.  */
      for (i = startnum; i <=endnum; i += stride)
        {
         framenum++;
         sprintf(number1,"%d",i);
         sprintf(sframenum,"%d",framenum);
      
         if (i < 10)
           {
            strcpy(number,"00");
            strcat(number,number1);
           }
         else if (i < 100)
           {
            strcpy(number,"0");
            strcat(number,number1);
           }
         else
           {
            strcpy(number,number1);
           }

         /*  Add 3 digit rgb output file no.  */
         if (framenum < 10)
           {
            strcpy(framenumstring,"00");
            strcat(framenumstring,sframenum);
           }
         else if (framenum < 100)
           {
            strcpy(framenumstring,"0");
            strcat(framenumstring,sframenum);
           }
         else
           {
            strcpy(framenumstring,sframenum);
           }

         /*  Copy CFS command into  header1 and the  */
         /*  input file name and no. into header2.   */
         strcpy(header1,header);
         strcpy(header2,path1);
         strcat(header2,number);

         /*  Build the input file name for the gmv command.  */
         /*  If input from CFS, do not include the path.     */ 
         if (cfs == 1)
           {
            strcpy(infile,strrchr(header2,'/')+1);
           }
         else
           {
            strcpy(infile,header2);
           }

         /*  Combine the CFS command with the file to get.  */
         strcat(header1,header2);

         /*  If not getting from local disk,  */
         /*  issue CFS command from header1.  */
         if (local == 0)
           {
            printf("Getting %s%s ... ",prefix,number);
            fflush(stdout);
            ret = 1;
            tries = 0;
            while ((ret != 0) && (tries < 6))
              {
               ret = system(header1);
          
               if (ret != 0)
                 {
                  printf("%d Unsuccessful; trying again ... \n",ret);
                  fflush(stdout);
                  sleep(100);
                  tries += 1;
                 }
              }
            if (tries < 5)
              {
               printf(" Got it ... ");
               fflush(stdout);
              }
            else
              {
               printf("Can't get file after 5 tries.  Quitting.\n");
               exit(0);
              }
           }

         /*  Complete gmv command from gmvinhdr and   */
         /*  infile, then add the snapshot argument.  */
         strcpy(gmvin,gmvinhdr);
         strcat(gmvin,infile);
         if (snapshot == 1) strcat(gmvin," -s");

         /*  Issue gmv command.  */
         printf("Running gmv on frame %d ... ",framenum);
         fflush(stdout); 
         ret = system(gmvin);

         /*  If input file NOT from local disk, delete it.  */
         if (local == 0)
           {
            strcpy(rmstring,"rm ");
            printf(" Removing %s",infile);
            fflush(stdout);
            strcat(rmstring,infile);        
            system(rmstring);
           }

         /*  Issue move command to rgv output file.  */
         printf("\n");
         strcpy(snapstring1,snapstring);
         strcat(snapstring1,framenumstring);
         system(snapstring1);
        }

      if (script == 0) loop = 0;

     }

}


void quit(w,client_data,call_data) 
 Widget w;
 XtPointer client_data, call_data;
{
   exit(0);
}


void ready(w,client_data,call_data) 
 Widget w;
 XtPointer client_data, call_data;
{
  int ierr, iquad, scriptcfs;
  char *tmpstr;
  XmString string;

  

   /*  Clear the message area.  */
   string = XmStringCreate(" ",
                           XmSTRING_DEFAULT_CHARSET);
   XtVaSetValues(msglab,XmNlabelString,string,NULL);
   XmStringFree(string);

   /*  Get and check input mode data.  */
   ierr = 0;
   local = (int)XmToggleButtonGadgetGetState(localbutton);
   script = (int)XmToggleButtonGadgetGetState(scriptbutton);
   cfs = (int)XmToggleButtonGadgetGetState(cfsbutton);
   scriptcfs = (int)XmToggleButtonGadgetGetState(scriptcfsbutton);
   if (scriptcfs == 1)
     {
      script = 1;
      cfs = 1;
     }
/*
   if (cray == 1)
     {
      tmpstr = XmTextFieldGetString(crayfield);
      strcpy(craymx,tmpstr);
      XtFree(tmpstr);
     }
*/
  
   /*  Get and check input file data.  */
   tmpstr = XmTextFieldGetString(pathfield);
   strcpy(path,tmpstr);
   XtFree(tmpstr);
   if (strlen(path) == 0) strcpy(path," ");
   tmpstr = XmTextFieldGetString(prefixfield);
   strcpy(prefix,tmpstr);
   XtFree(tmpstr);
   if (strlen(prefix) == 0) strcpy(prefix," ");
   startnum = atoi(XmTextFieldGetString(firstfield));
   endnum = atoi(XmTextFieldGetString(lastfield));
   stride = atoi(XmTextFieldGetString(stridefield));
   tmpstr = XmTextFieldGetString(attributesfield);
   strcpy(attributesfile,tmpstr);
   XtFree(tmpstr);
   if (strlen(attributesfile) == 0) strcpy(attributesfile," ");
   tmpstr = XmTextFieldGetString(scriptfield);
   strcpy(scriptfile,tmpstr);
   XtFree(tmpstr);
   if (strlen(scriptfile) == 0) strcpy(scriptfile," ");
   if (startnum > endnum)
     {
      string = XmStringCreate("Error, last must be > first.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   if (stride <= 0 && ierr == 0)
     {
      string = XmStringCreate("Error, stride must be > 0.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   if (strncmp(prefix," ",1) == 0 && ierr == 0)
     {
      string = XmStringCreate("Error, enter file prefix.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   if (strncmp(attributesfile," ",1) == 0 && ierr == 0)
     {
      string = XmStringCreate("Error, enter attributes file.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   if (cfs == 1 && strncmp(path," ",1) == 0 && ierr == 0)
     {
      string = XmStringCreate("Error, enter a directory.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   if (script == 1 && strncmp(scriptfile," ",1) == 0 && ierr == 0)
     {
      string = XmStringCreate("Error, enter the script file name.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }

   /*  Get and check quadrant.  */
   iquad = 0;
   if (XmToggleButtonGadgetGetState(quad1)) iquad = 1;
   if (XmToggleButtonGadgetGetState(quad2)) iquad = 2;
   if (XmToggleButtonGadgetGetState(quad3)) iquad = 3;
   if (XmToggleButtonGadgetGetState(quad4)) iquad = 4;
   if (iquad == 0) iquad == 4;
   if (iquad == 1) strcpy(win_pos," -w 0 511 640 512 -i ");
   if (iquad == 2) strcpy(win_pos," -w 639 511 640 512 -i ");
   if (iquad == 3) strcpy(win_pos," -w 0 0 640 512 -i ");
   if (iquad == 4) strcpy(win_pos," -w 639 0 640 512 -i ");
  
   /*  Get and check rgb output file data.  */
   tmpstr = XmTextFieldGetString(rgbfield);
   strcpy(rgbprefix,tmpstr);
   XtFree(tmpstr);
   if (strlen(rgbprefix) == 0) strcpy(rgbprefix," ");
   if (strncmp(rgbprefix," ",1) == 0 && ierr == 0)
     {
      string = XmStringCreate("Error, enter RGB file prefix.",
                              XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(msglab,XmNlabelString,string,NULL);
      XmStringFree(string);
      ierr = 1;
     }
   startrgbno = atoi(XmTextFieldGetString(rgbstart));
   if (startrgbno < 1) startrgbno = 1;

   if (ierr == 0) continueflag = 1;
}


void create_form_mainform(toplevel)
 Widget toplevel;
{
  Widget mainform;
  Widget inputlab, inputbox, dirlab, prefixlab, firstlab, lastlab,
         stridelab, attrlab, quadlab, quadbox, craylab, startlab,
         rgblab, scriptlab;
  Arg args[20];
  int i;
  unsigned long whitepix;
  XmString string;

   mainform = XmCreateForm(toplevel,"Mainform",NULL,0);
   XtManageChild(mainform);
 
   string = XmStringCreate("Input Mode:",XmSTRING_DEFAULT_CHARSET);
   inputlab = XtVaCreateManagedWidget("Inputlab",
              xmLabelWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_FORM,
              XmNtopOffset, 5,
              XmNleftAttachment, XmATTACH_FORM,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNlabelString, string,
              NULL);
      XmStringFree(string);

   i=0;  XtSetArg(args[i],XmNtopAttachment, XmATTACH_FORM);
   i++;  XtSetArg(args[i],XmNleftAttachment, XmATTACH_WIDGET);
   i++;  XtSetArg(args[i],XmNleftWidget, inputlab);
   i++;  XtSetArg(args[i],XmNrightAttachment, XmATTACH_NONE);
   i++;  XtSetArg(args[i],XmNbottomAttachment, XmATTACH_NONE);
   i++;  XtSetArg(args[i],XmNorientation, XmHORIZONTAL);
   i++;  XtSetArg(args[i],XmNnumColumns, 2);
   i++;
   inputbox = XmCreateRadioBox(mainform,"Inputbox",args,i);
   XtManageChild(inputbox);

   string = XmStringCreate("Local",XmSTRING_DEFAULT_CHARSET);
   localbutton = XtVaCreateManagedWidget("Localbutton",
                 xmToggleButtonGadgetClass,
                 inputbox,
                 XmNlabelString, string,
                 XmNspacing, 1,
                 XmNmarginHeight, 0,
                 XmNmarginWidth, 0,
                 XmNset, TRUE,
                 NULL);
      XmStringFree(string);

   string = XmStringCreate("Script",XmSTRING_DEFAULT_CHARSET);
   scriptbutton = XtVaCreateManagedWidget("Scriptbutton",
                 xmToggleButtonGadgetClass,
                 inputbox,
                 XmNlabelString, string,
                 XmNspacing, 1,
                 XmNmarginHeight, 0,
                 XmNmarginWidth, 0,
                 NULL);
      XmStringFree(string);

   string = XmStringCreate("CFS",XmSTRING_DEFAULT_CHARSET);
   cfsbutton = XtVaCreateManagedWidget("Cfsbutton",
               xmToggleButtonGadgetClass,
               inputbox,
               XmNlabelString, string,
               XmNspacing, 1,
               XmNmarginHeight, 0,
               XmNmarginWidth, 0,
               NULL);
      XmStringFree(string);

   string = XmStringCreate("Script and CFS",XmSTRING_DEFAULT_CHARSET);
   scriptcfsbutton = XtVaCreateManagedWidget("Scriptcfsbutton",
                     xmToggleButtonGadgetClass,
                     inputbox,
                     XmNlabelString, string,
                     XmNspacing, 1,
                     XmNmarginHeight, 0,
                     XmNmarginWidth, 0,
                     NULL);
      XmStringFree(string);

/*
   string = XmStringCreate("Cray",XmSTRING_DEFAULT_CHARSET);
   craybutton = XtVaCreateManagedWidget("Craybutton",
                 xmToggleButtonGadgetClass,
                 inputbox,
                 XmNlabelString, string,
                 XmNspacing, 1,
                 XmNmarginHeight, 0,
                 XmNmarginWidth, 0,
                 NULL);
      XmStringFree(string);

   crayfield = XtVaCreateManagedWidget("Crayfield",
               xmTextFieldWidgetClass,
               mainform,
               XmNtopAttachment, XmATTACH_FORM,
               XmNleftAttachment, XmATTACH_WIDGET,
               XmNleftWidget, inputbox,
               XmNrightAttachment, XmATTACH_NONE,
               XmNbottomAttachment, XmATTACH_NONE,
               XmNmaxLength, 2,
               XmNcolumns, 2,
               XmNvalue, "",
               NULL);  
 
   string = XmStringCreate("Which Cray?",XmSTRING_DEFAULT_CHARSET);
   craylab = XtVaCreateManagedWidget("Craylab",
              xmLabelWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_FORM,
              XmNtopOffset, 5,
              XmNleftAttachment, XmATTACH_WIDGET,
              XmNleftWidget, crayfield,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNlabelString, string,
              NULL);
      XmStringFree(string);
*/

   pathfield = XtVaCreateManagedWidget("Pathfield",
               xmTextFieldWidgetClass,
               mainform,
               XmNtopAttachment, XmATTACH_WIDGET,
               XmNtopWidget, inputbox,
               XmNtopOffset, 10,
               XmNleftAttachment, XmATTACH_FORM,
               XmNrightAttachment, XmATTACH_NONE,
               XmNbottomAttachment, XmATTACH_NONE,
               XmNmaxLength, 200,
               XmNcolumns, 40,
               XmNvalue, "",
               NULL);  
   string = XmStringCreate("CFS Directory or Alternate Path",
                           XmSTRING_DEFAULT_CHARSET);
   dirlab = XtVaCreateManagedWidget("Dirlab",
            xmLabelWidgetClass,
            mainform,
            XmNtopAttachment, XmATTACH_WIDGET,
            XmNtopWidget, pathfield,
            XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
            XmNleftWidget, pathfield,
            XmNrightAttachment, XmATTACH_NONE,
            XmNbottomAttachment, XmATTACH_NONE,
            XmNlabelString, string,
            NULL);
      XmStringFree(string);

   prefixfield = XtVaCreateManagedWidget("Prefixfield",
                 xmTextFieldWidgetClass,
                 mainform,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNtopWidget, inputbox,
                 XmNtopOffset, 10,
                 XmNleftAttachment, XmATTACH_WIDGET,
                 XmNleftWidget, pathfield,
                 XmNrightAttachment, XmATTACH_NONE,
                 XmNbottomAttachment, XmATTACH_NONE,
                 XmNmaxLength, 40,
                 XmNcolumns, 20,
                 XmNvalue, "",
                 NULL);  
   string = XmStringCreate("File Prefix",XmSTRING_DEFAULT_CHARSET);
   prefixlab = XtVaCreateManagedWidget("Prefixlab",
               xmLabelWidgetClass,
               mainform,
               XmNtopAttachment, XmATTACH_WIDGET,
               XmNtopWidget, prefixfield,
               XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
               XmNleftWidget, prefixfield,
               XmNrightAttachment, XmATTACH_NONE,
               XmNbottomAttachment, XmATTACH_NONE,
               XmNlabelString, string,
               NULL);
      XmStringFree(string);

   firstfield = XtVaCreateManagedWidget("Firstfield",
                xmTextFieldWidgetClass,
                mainform,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNtopWidget, dirlab,
                XmNtopOffset, 10,
                XmNleftAttachment, XmATTACH_FORM,
                XmNrightAttachment, XmATTACH_NONE,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNmaxLength, 5,
                XmNcolumns, 5,
                XmNvalue, "    1",
                NULL);  
   string = XmStringCreate("First",XmSTRING_DEFAULT_CHARSET);
   firstlab = XtVaCreateManagedWidget("Firstlab",
              xmLabelWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_WIDGET,
              XmNtopWidget, firstfield,
              XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
              XmNleftWidget, firstfield,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNlabelString, string,
              NULL);
      XmStringFree(string);

   lastfield = XtVaCreateManagedWidget("Lastfield",
               xmTextFieldWidgetClass,
               mainform,
               XmNtopAttachment, XmATTACH_WIDGET,
               XmNtopWidget, dirlab,
               XmNtopOffset, 10,
               XmNleftAttachment, XmATTACH_WIDGET,
               XmNleftWidget, firstfield,
               XmNrightAttachment, XmATTACH_NONE,
               XmNbottomAttachment, XmATTACH_NONE,
               XmNmaxLength, 5,
               XmNcolumns, 5,
               XmNvalue, "    1",
               NULL);  
   string = XmStringCreate("Last",XmSTRING_DEFAULT_CHARSET);
   lastlab = XtVaCreateManagedWidget("Lastlab",
             xmLabelWidgetClass,
             mainform,
             XmNtopAttachment, XmATTACH_WIDGET,
             XmNtopWidget, lastfield,
             XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
             XmNleftWidget, lastfield,
             XmNrightAttachment, XmATTACH_NONE,
             XmNbottomAttachment, XmATTACH_NONE,
             XmNlabelString, string,
             NULL);
      XmStringFree(string);

   stridefield = XtVaCreateManagedWidget("Stridefield",
                 xmTextFieldWidgetClass,
                 mainform,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNtopWidget, dirlab,
                 XmNtopOffset, 10,
                 XmNleftAttachment, XmATTACH_WIDGET,
                 XmNleftWidget, lastfield,
                 XmNrightAttachment, XmATTACH_NONE,
                 XmNbottomAttachment, XmATTACH_NONE,
                 XmNmaxLength, 5,
                 XmNcolumns, 5,
                 XmNvalue, "    1",
                 NULL);  
   string = XmStringCreate("Stride",XmSTRING_DEFAULT_CHARSET);
   stridelab = XtVaCreateManagedWidget("Stridelab",
               xmLabelWidgetClass,
               mainform,
               XmNtopAttachment, XmATTACH_WIDGET,
               XmNtopWidget, stridefield,
               XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
               XmNleftWidget, stridefield,
               XmNrightAttachment, XmATTACH_NONE,
               XmNbottomAttachment, XmATTACH_NONE,
               XmNlabelString, string,
               NULL);
      XmStringFree(string);

   attributesfield = XtVaCreateManagedWidget("Attributesfield",
                     xmTextFieldWidgetClass,
                     mainform,
                     XmNtopAttachment, XmATTACH_WIDGET,
                     XmNtopWidget, stridelab,
                     XmNtopOffset, 10,
                     XmNleftAttachment, XmATTACH_FORM,
                     XmNrightAttachment, XmATTACH_NONE,
                     XmNbottomAttachment, XmATTACH_NONE,
                     XmNmaxLength, 200,
                     XmNcolumns, 20,
                     XmNvalue, "",
                     NULL);  
   string = XmStringCreate("Attributes File",
                           XmSTRING_DEFAULT_CHARSET);
   attrlab = XtVaCreateManagedWidget("Attrlab",
             xmLabelWidgetClass,
             mainform,
             XmNtopAttachment, XmATTACH_WIDGET,
             XmNtopWidget, attributesfield,
             XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
             XmNleftWidget, attributesfield,
             XmNrightAttachment, XmATTACH_NONE,
             XmNbottomAttachment, XmATTACH_NONE,
             XmNlabelString, string,
             NULL);
      XmStringFree(string);

   scriptfield = XtVaCreateManagedWidget("Scriptfield",
                 xmTextFieldWidgetClass,
                 mainform,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNtopWidget, stridelab,
                 XmNtopOffset, 10,
                 XmNleftAttachment, XmATTACH_WIDGET,
                 XmNleftWidget, attributesfield,
                 XmNleftOffset, 10,
                 XmNrightAttachment, XmATTACH_NONE,
                 XmNbottomAttachment, XmATTACH_NONE,
                 XmNmaxLength, 80,
                 XmNcolumns, 20,
                 XmNvalue, "",
                 NULL);  
   string = XmStringCreate("Script File",
                           XmSTRING_DEFAULT_CHARSET);
   scriptlab = XtVaCreateManagedWidget("Scriptlab",
             xmLabelWidgetClass,
             mainform,
             XmNtopAttachment, XmATTACH_WIDGET,
             XmNtopWidget, scriptfield,
             XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
             XmNleftWidget, scriptfield,
             XmNrightAttachment, XmATTACH_NONE,
             XmNbottomAttachment, XmATTACH_NONE,
             XmNlabelString, string,
             NULL);
      XmStringFree(string);
 
   string = XmStringCreate("Screen Quadrant:",
                           XmSTRING_DEFAULT_CHARSET);
   quadlab = XtVaCreateManagedWidget("quadlab",
             xmLabelWidgetClass,
             mainform,
             XmNtopAttachment, XmATTACH_WIDGET,
             XmNtopWidget, attrlab,
             XmNtopOffset, 15,
             XmNleftAttachment, XmATTACH_FORM,
             XmNrightAttachment, XmATTACH_NONE,
             XmNbottomAttachment, XmATTACH_NONE,
             XmNlabelString, string,
             NULL);
      XmStringFree(string);

   i=0;  XtSetArg(args[i],XmNtopAttachment, XmATTACH_WIDGET);
   i++;  XtSetArg(args[i],XmNtopWidget, attrlab);
   i++;  XtSetArg(args[i],XmNtopOffset, 10);
   i++;  XtSetArg(args[i],XmNleftAttachment, XmATTACH_WIDGET);
   i++;  XtSetArg(args[i],XmNleftWidget, quadlab);
   i++;  XtSetArg(args[i],XmNrightAttachment, XmATTACH_NONE);
   i++;  XtSetArg(args[i],XmNbottomAttachment, XmATTACH_NONE);
   i++;  XtSetArg(args[i],XmNorientation, XmHORIZONTAL);
   i++;  XtSetArg(args[i],XmNnumColumns, 2);
   i++;
   quadbox = XmCreateRadioBox(mainform,"Quadbox",args,i);
   XtManageChild(quadbox);

   string = XmStringCreate("Top Left",XmSTRING_DEFAULT_CHARSET);
   quad1 = XtVaCreateManagedWidget("Quad1",
           xmToggleButtonGadgetClass,
           quadbox,
           XmNlabelString, string,
           XmNspacing, 1,
           XmNmarginHeight, 0,
           XmNmarginWidth, 0,
           NULL);
      XmStringFree(string);

   string = XmStringCreate("Top Right",XmSTRING_DEFAULT_CHARSET);
   quad2 = XtVaCreateManagedWidget("Quad2",
           xmToggleButtonGadgetClass,
           quadbox,
           XmNlabelString, string,
           XmNspacing, 1,
           XmNmarginHeight, 0,
           XmNmarginWidth, 0,
           NULL);
      XmStringFree(string);

   string = XmStringCreate("Bottom Left",XmSTRING_DEFAULT_CHARSET);
   quad3 = XtVaCreateManagedWidget("Quad3",
           xmToggleButtonGadgetClass,
           quadbox,
           XmNlabelString, string,
           XmNspacing, 1,
           XmNmarginHeight, 0,
           XmNmarginWidth, 0,
           NULL);
      XmStringFree(string);

   string = XmStringCreate("Bottom Right",XmSTRING_DEFAULT_CHARSET);
   quad4 = XtVaCreateManagedWidget("Quad4",
           xmToggleButtonGadgetClass,
           quadbox,
           XmNlabelString, string,
           XmNspacing, 1,
           XmNmarginHeight, 0,
           XmNmarginWidth, 0,
           XmNset, TRUE,
           NULL);
      XmStringFree(string);

   rgbfield = XtVaCreateManagedWidget("Rgbfield",
              xmTextFieldWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_WIDGET,
              XmNtopWidget, quadbox,
              XmNtopOffset, 10,
              XmNleftAttachment, XmATTACH_FORM,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNmaxLength, 40,
              XmNcolumns, 20,
              XmNvalue, "msnapgmv",
              NULL);  
   string = XmStringCreate("RGB File Prefix",XmSTRING_DEFAULT_CHARSET);
   rgblab = XtVaCreateManagedWidget("Suffixlab",
            xmLabelWidgetClass,
            mainform,
            XmNtopAttachment, XmATTACH_WIDGET,
            XmNtopWidget, rgbfield,
            XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
            XmNleftWidget, rgbfield,
            XmNrightAttachment, XmATTACH_NONE,
            XmNbottomAttachment, XmATTACH_NONE,
            XmNlabelString, string,
            NULL);
      XmStringFree(string);

   rgbstart = XtVaCreateManagedWidget("Startcount",
              xmTextFieldWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_WIDGET,
              XmNtopWidget, quadbox,
              XmNtopOffset, 10,
              XmNleftAttachment, XmATTACH_WIDGET,
              XmNleftWidget, rgbfield,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNmaxLength, 5,
              XmNcolumns, 5,
              XmNvalue, "    1",
              NULL);  
   string = XmStringCreate("RGB Start No.",XmSTRING_DEFAULT_CHARSET);
   startlab = XtVaCreateManagedWidget("Startlab",
              xmLabelWidgetClass,
              mainform,
              XmNtopAttachment, XmATTACH_WIDGET,
              XmNtopWidget, rgbstart,
              XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET,
              XmNleftWidget, rgbstart,
              XmNrightAttachment, XmATTACH_NONE,
              XmNbottomAttachment, XmATTACH_NONE,
              XmNlabelString, string,
              NULL);
      XmStringFree(string);

 
   string = XmStringCreate("Quit",XmSTRING_DEFAULT_CHARSET);
   quitbutton = XtVaCreateManagedWidget("Quitbutton",
                xmPushButtonGadgetClass,
                mainform,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNtopWidget, rgblab,
                XmNtopOffset, 10,
                XmNleftAttachment, XmATTACH_FORM,
                XmNrightAttachment, XmATTACH_NONE,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNlabelString, string,
                NULL);
      XmStringFree(string);
      XtAddCallback(quitbutton,XmNactivateCallback,quit,NULL);

   string = XmStringCreate("Ready",XmSTRING_DEFAULT_CHARSET);
   readybutton = XtVaCreateManagedWidget("Readybutton",
                 xmPushButtonGadgetClass,
                 mainform,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNtopWidget, rgblab,
                 XmNtopOffset, 10,
                 XmNleftAttachment, XmATTACH_WIDGET,
                 XmNleftWidget, quitbutton,
                 XmNleftOffset, 10,
                 XmNrightAttachment, XmATTACH_NONE,
                 XmNbottomAttachment, XmATTACH_NONE,
                 XmNlabelString, string,
                 NULL);
      XmStringFree(string);
      XtAddCallback(readybutton,XmNactivateCallback,ready,NULL);
 
   string = XmStringCreate(" ",XmSTRING_DEFAULT_CHARSET);
   msglab = XtVaCreateManagedWidget("Msglab",
            xmLabelWidgetClass,
            mainform,
            XmNtopAttachment, XmATTACH_WIDGET,
            XmNtopWidget, rgblab,
            XmNtopOffset, 10,
            XmNleftAttachment, XmATTACH_WIDGET,
            XmNleftWidget, readybutton,
            XmNrightAttachment, XmATTACH_NONE,
            XmNbottomAttachment, XmATTACH_NONE,
            XmNlabelString, string,
            NULL);
      XmStringFree(string);
}
